local Rect = {}
Rect.__index = Rect


function new(x,y,w,h)
	local self = setmetatable({}, Rect)
	self.x = x
	self.y = y
	self.width = w
	self.height = h
	return self
end

function Rect:center()
	return {self.x+self.width/2, self.y+self.height/2}
end 

function Rect:centerx()
	return self.x+self.width/2
end

function Rect:centery()
	return self.y+self.height/2
end

function Rect:setCenter(x,y)
	self.x = x-self.width/2
	self.y = y-self.height/2
end

function Rect:move(x,y)
	self.x = self.x + x
	self.y = self.y + y 
end

function Rect:contains(rect) -- contains
  -- Test whether self is inside rect.
  return rect.x > self.x and rect.y > self.y and rect.x+rect.width < self.x+self.width and rect.y+rect.height < self.y+self.height
end

function Rect:colliderect(rect) -- colliderect
  return self.x < rect.x+rect.width and
         rect.x < self.x+self.width and
		 self.y < rect.y+rect.height and
		 rect.y < self.y+self.height
end

function Rect:collidepoint(x,y)
	return (x >= self.x and x <= self.x+self.width) and (y >= self.y and y <= self.y+self.height)
end 

return new
