


Rect    = require("Rect")

local screenWidth, screenHeight = love.graphics.getDimensions()
local rect1, rect2

function love.load()
	rect1 = Rect(100,100,50,50)
	rect2 = Rect(200,200,100,100)
end

function love.update(dt)
	if love.keyboard.isDown("left") and rect1.x>0 then
		rect1:move(-100*dt,0)
	end
	if love.keyboard.isDown("right") and rect1.x<screenWidth then
		rect1:move(100*dt,0)
	end
	if love.keyboard.isDown("up") and rect1.y>0 then
		rect1:move(0,-100*dt)
	end
	if love.keyboard.isDown("down") and rect1.y<screenHeight then
		rect1:move(0,100*dt)
	end
	
	if love.keyboard.isDown("a") and rect2.x>0 then
		rect2:move(-100*dt,0)
	end
	if love.keyboard.isDown("d") and rect2.x<screenWidth then
		rect2:move(100*dt,0)
	end
	if love.keyboard.isDown("w") and rect2.y>0 then
		rect2:move(0,-100*dt)
	end
	if love.keyboard.isDown("s") and rect2.y<screenHeight then
		rect2:move(0,100*dt)
	end
end

function love.keypressed(key, unicode, isrepeat)
	if key == "space" then
		rect1:setCenter(rect2:centerx(),rect2:centery())
	end
end

function love.draw()
	love.graphics.print("Colliding?: " .. tostring(rect1:colliderect(rect2)), 10,10)
	love.graphics.print("rect1 colliding with mouse?: " .. tostring(rect1:collidepoint(love.mouse.getX(),love.mouse.getY())), 10,30)
	love.graphics.print("rect2 colliding with mouse?: " .. tostring(rect2:collidepoint(love.mouse.getX(),love.mouse.getY())), 10,50)
	love.graphics.print("rect2 containing rect1?: " .. tostring(rect2:contains(rect1)), 10,70)
	love.graphics.rectangle("line",rect1.x,rect1.y,rect1.width,rect1.height)
	love.graphics.rectangle("line",rect2.x,rect2.y,rect2.width,rect2.height)
end
